package edu.mermet.tp8.fenetres.modales;

import edu.mermet.tp8.Application;

import java.awt.Frame ;
import java.awt.GridLayout ;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

import javax.swing.BoxLayout ;
import javax.swing.ButtonGroup ;
import javax.swing.JButton ;
import javax.swing.JDialog ;
import javax.swing.JLabel ;
import javax.swing.JPanel ;
import javax.swing.JRadioButton ;

/**
 * Classe permettant de gérer les préférences utilisateur
 */
public class ConfigurationMenusDialogue extends JDialog {

    private JLabel conversion;
    private JLabel saisie;
    private JLabel diapo;
    private JLabel boutons;

    private JRadioButton conversionAuto;
    private JRadioButton saisieAuto;
    private JRadioButton diapoAuto;
    private JRadioButton boutonsAuto;

    private JRadioButton conversionAffiche;
    private JRadioButton saisieAffiche;
    private JRadioButton diapoAffiche;
    private JRadioButton boutonsAffiche;

    private JRadioButton conversionCache;
    private JRadioButton saisieCache;
    private JRadioButton diapoCache;
    private JRadioButton boutonsCache;

    private ButtonGroup convGroup;
    private ButtonGroup saisieGroup;
    private ButtonGroup diapoGroup;
    private ButtonGroup boutonsGroup;

    private JButton valider;
    private JButton annuler;

    private JPanel grille;
    private JPanel valAnn;

    private Application owner;

    /**
     * Constructeur ConfigurationMenusDialogue
     * @param owner
     */
    public ConfigurationMenusDialogue(Application owner) {
        super(owner,"Configuration des menus", true);
        this.owner = owner;
        init();
    }

    public void init() {
        contents();
        pack();
        setLocationRelativeTo(null);
        setVisible(true);
    }

    private void contents() {
        setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
        GridLayout grid = new GridLayout(4,4);
        grille = new JPanel(grid);
        valAnn = new JPanel();
        remplPanes();
        add(grille);
        add(valAnn);
    }

    private void remplPanes ( ) {
        convGroup = new ButtonGroup();
        conversion = new JLabel("Conversion Celsius/Farenheit"); grille.add(conversion);
        conversionAuto = new JRadioButton("Auto");conversionAuto.setActionCommand("Auto");grille.add(conversionAuto);
        conversionAffiche = new JRadioButton("Affiche");conversionAffiche.setActionCommand("Affiche");grille.add(conversionAffiche);
        conversionCache = new JRadioButton("Caché");conversionCache.setActionCommand("Caché");grille.add(conversionCache);
        convGroup.add (conversionAuto);convGroup.add (conversionAffiche);convGroup.add(conversionCache);

        saisieGroup = new ButtonGroup();
        saisie = new JLabel("Saisie de texte");grille.add(saisie);
        saisieAuto = new JRadioButton("Auto");saisieAuto.setActionCommand("Auto");grille.add(saisieAuto);
        saisieAffiche = new JRadioButton("Affiche");saisieAffiche.setActionCommand("Affiche");grille.add(saisieAffiche);
        saisieCache = new JRadioButton("Caché");saisieCache.setActionCommand("Caché");grille.add(saisieCache);
        saisieGroup.add (saisieAuto);saisieGroup.add (saisieAffiche);saisieGroup.add(saisieCache);

        diapoGroup = new ButtonGroup();
        diapo = new JLabel("Diaporama");grille.add(diapo);
        diapoAuto = new JRadioButton("Auto");diapoAuto.setActionCommand("Auto");grille.add(diapoAuto);
        diapoAffiche = new JRadioButton("Affiche");diapoAffiche.setActionCommand("Affiche");grille.add(diapoAffiche);
        diapoCache = new JRadioButton("Caché");diapoCache.setActionCommand("Caché");grille.add(diapoCache);
        diapoGroup.add (diapoAuto);diapoGroup.add (diapoAffiche);diapoGroup.add(diapoCache);

        boutonsGroup = new ButtonGroup();
        boutons = new JLabel("Boutons");grille.add(boutons);
        boutonsAuto = new JRadioButton("Auto");boutonsAuto.setActionCommand("Auto");grille.add(boutonsAuto);
        boutonsAffiche = new JRadioButton("Affiche");boutonsAffiche.setActionCommand("Affiche");grille.add(boutonsAffiche);
        boutonsCache = new JRadioButton("Caché");boutonsCache.setActionCommand("Caché");grille.add(boutonsCache);
        boutonsGroup.add (boutonsAuto);boutonsGroup.add (boutonsAffiche);boutonsGroup.add(boutonsCache);

        valider = new JButton("Valider");valAnn.add (valider);
        annuler = new JButton("Annuler");valAnn.add (annuler);

        valider.addActionListener(new EnregistrementPreferences());
    }

    /**
     * Classe permettant de stocker les préférences de l'utilisateur
     */
    private class EnregistrementPreferences implements ActionListener {

        public EnregistrementPreferences(){}

        @Override
        public void actionPerformed(ActionEvent e) {
            try {
                Properties properties = new Properties();

                if(convGroup.getSelection() != null) {
                    properties.setProperty("conversion", convGroup.getSelection().getActionCommand());
                }

                if(saisieGroup.getSelection() != null) {
                    properties.setProperty("saisie", saisieGroup.getSelection().getActionCommand());
                }

                if(diapoGroup.getSelection() != null) {
                    properties.setProperty("diaporama", diapoGroup.getSelection().getActionCommand());
                }


                if(boutonsGroup.getSelection() != null) {
                    properties.setProperty("boutons", boutonsGroup.getSelection().getActionCommand());
                }


                File file = new File("src/main/resources/.ihm/" + owner.getUtilisateur() + ".xml");
                boolean fichierExiste = file.exists();

                FileOutputStream fileOut = new FileOutputStream(file);
                properties.storeToXML(fileOut, "ok");
                fileOut.close();


            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
            } catch (IOException ioe) {
                ioe.printStackTrace();
            }

            dispose();
        }
    }

}
